#ifndef	HEADER_IMWIN
#define	HEADER_IMWIN

#include "pic.h"
#include "screen.h"
#include "fifo.h"

  /* 摜EBhE */

#define	IMAGEWIN_TITLE	129

	typedef struct _imw {
		struct _imw	*next;
	  	/* eiID */
			int			win;			/* EBhEi */
			int			sbar_h;
			int			sbar_v;
			// int			btn;			/* `̈p{^ */
			int			erasebtn;
			int			titlebar;
			int			titlemsg;
		char		title[IMAGEWIN_TITLE+1];
		char		fname[_MAX_PATH];
		PIC			*pic;
		SCRBITMAP	bm;				// ʏo͗prbg}bv
		int			zoom;			// g嗦
		BOOL		fBoxRubber;
		FRAME		frBoxRubber;	// BOXo[ PIC ̈(x,y,wid,ht)
		BOOL		fBoxRubber2;
		FRAME		frBoxRubber2;	// BOXo[Q
		BOOL		fLineRubber;
		LIST*		listLineRubber;
		BOOL		fLineRubber2;
		LIST*		listLineRubber2;
	} IMWIN;

  // W[
	int imagewin_init(void);

  // E
	IMWIN *imagewin_new(int pixelsize,int width, int height);
	void imagewin_destroy(IMWIN *win);

  // N֘A
	IMWIN *imagewin_getfirst(void);
	IMWIN *imagewin_getnext(void);
	void imagewin_link(IMWIN *win);
	void imagewin_unlink(IMWIN *win);
	void imagewin_show(IMWIN *win);
	IMWIN *imagewin_getWinFromPart(int objId);
		// IuWFNghcEBhE
	IMWIN *imagewin_getCurrentWin(void);
	void imagewin_setCurrentWin(IMWIN *win);

  // Wϊ
	void imagewin_getScrFrame(IMWIN *win, FRAME *frPic, FRAME *frBitmap);
		// PIC̈(x,y,wid,ht)ASCRBITMAP̈(x,y,wid,ht)ւƕϊ
	void imagewin_getDispFrame(IMWIN *win,FRAME* frPic);
		// EBhẼ[U[̈A\摜 PIC ̈(x,y,wid,ht)ɕϊ
	void imagewin_getPosFromMos(IMWIN *win, POINT *mos, POINT *pos);
		// ʏ̃}EXWA摜ł̈ʒu𓾂
	BOOL imagewin_PtInPic(IMWIN* win, POINT* pt);
		// ʍW pt EBhẺ摜̈ɂ邩ǂ

  // \eXV
	void imagewin_updateBuf(IMWIN *win);
		// PICeASCRBITMAPŜĐ
	void imagewin_updateScr(IMWIN *win);
		// SCRBITMAP̓eʂɕ\BɃo[`s
	void imagewin_updateScrPart(IMWIN *win, FRAME *updatefr);
		// PIC̈ updatefr ɑΉ SCRBITMAP / ʂXV

  // o[
	void imagewin_setBoxRubber(IMWIN* win, FRAME *fr);
		// fr : PIC̈(x,y,wid,ht)
	void imagewin_setBoxRubber2(IMWIN* win, FRAME *fr);
	void imagewin_clearBoxRubber(IMWIN* win);
	void imagewin_clearBoxRubber2(IMWIN* win);
	void imagewin_resetLineRubber(IMWIN* win);
	void imagewin_addLineRubber(IMWIN* win,POINT* p1,POINT* p2);
		// p1,p2 : PIC W   p2  NULL ̂ƂAXg̍ŏ̓_Ƃނ
	int imagewin_nLineRubber(IMWIN* win);
	void imagewin_clearLineRubber(IMWIN* win);
	void imagewin_resetLineRubber2(IMWIN* win);
	void imagewin_addLineRubber2(IMWIN* win,POINT* p1,POINT* p2);
		// p1,p2 : PIC W   p2  NULL ̂ƂAXg̍ŏ̓_Ƃނ
	int imagewin_nLineRubber2(IMWIN* win);
	void imagewin_clearLineRubber2(IMWIN* win);

  // TCY
	int imagewin_resize(IMWIN *win, BOOL fRedraw);
		// qEBhE̍Ĕzu
	void imagewin_setZoom(IMWIN *win, int zoom);
	void imagewin_updateTitle(IMWIN *win, BOOL fShow);
	void imagewin_setFileName(IMWIN *win, char *fname, BOOL fShow);

  // 摜ҏW
	void imagewin_storeUndo(IMWIN* win);
	void imagewin_recoverUndo(void);
	void imagewin_copy(IMWIN* srcwin,FRAME* frSrc,
					   IMWIN* destwin,POINT *ptDest);
		// frSrc:PIC̈(x,y,wid,ht)
		// ptDest:PICW
	void imagewin_copyarea(IMWIN* srcwin,AREA areaSrc,
						   IMWIN* destwin,POINT *ptDest);

#define	BAR_SIZE	16

#endif	HEADER_IMWIN
